"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _token = require("illuminate-js/lib/token");

var _token2 = _interopRequireDefault(_token);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var TokenElem = _react2.default.createClass({
    displayName: "TokenElem",

    propTypes: {
        token: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.array, _react.PropTypes.instanceOf(_token2.default)]).isRequired
    },
    render: function render() {
        var token = this.props.token;

        if (typeof token === "string") {
            return _react2.default.createElement(
                "span",
                null,
                token
            );
        }

        if (Array.isArray(token)) {
            return _react2.default.createElement(
                "span",
                null,
                token.map(function (t, i) {
                    return _react2.default.createElement(TokenElem, { token: t, key: i });
                })
            );
        }

        var classes = ["token", token.type];

        if (token.alias) {
            var aliases = Array.isArray(token.alias) ? token.alias : [token.alias];

            classes.push.apply(classes, _toConsumableArray(aliases));
        }

        return _react2.default.createElement(
            "span",
            { className: classes.join(" ") },
            _react2.default.createElement(TokenElem, { token: token.content })
        );
    }
});

exports.default = TokenElem;