"use strict";

import React, { PropTypes } from "react";
import Token from "illuminate-js/lib/token";

let TokenElem = React.createClass({
    propTypes: {
        token: PropTypes.oneOfType([
            PropTypes.string,
            PropTypes.array,
            PropTypes.instanceOf(Token)
        ]).isRequired
    },
    render() {
        let { token } = this.props;

        if (typeof token === "string") {
            return <span>{token}</span>;
        }

        if (Array.isArray(token)) {
            return (
                <span>
                    {token.map((t, i) => (
                        <TokenElem token={t} key={i}/>
                    ))}
                </span>
            );
        }

        let classes = ["token", token.type];

        if (token.alias) {
            let aliases = Array.isArray(token.alias) ? token.alias : [token.alias];

            classes.push(...aliases);
        }

        return (
            <span className={classes.join(" ")}>
                <TokenElem token={token.content}/>
            </span>
        );
    }
});

export default TokenElem;
